
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.LayoutManager;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.event.WindowEvent;
import javax.swing.JApplet;
import javax.swing.JButton;
import javax.swing.JLabel;

public class PointsIQ extends JApplet implements Variables,Runnable,MouseMotionListener,MouseListener{

	int preX=0,preY=0;
	JButton butText,butNext,butSGF,butRePlay;
	QuestionIO base;
	Question question;
	int curQuestion=0;
	int curLevel=0;String preLevels="";Point AIAnswer=null;
	JLabel label=new JLabel();
	protected JLabel labelCoordinates=new JLabel();
	public Thread t=new Thread(this);
	public SingleGameEngine singleGameEngine;
	public DrawSingleGameEngine OP_paint=new DrawSingleGameEngine();
	private Graphics graphics;
	int qNumber=0,qLevel=0,qTrue=0,qThis=0;
	boolean isComplete=true,isRePlay=false;
	JButton but0,but1,but2,but3,but4;
	
void setLevel(int level){
	curQuestion=0;
	try{repaint();}catch(Exception e){}
	
	butText.setVisible(true);labelCoordinates.setVisible(true);label.setVisible(true);butNext.setVisible(true);	butRePlay.setVisible(true);
	//System.out.println("level "+level);
	
	but1.setEnabled(false);but2.setEnabled(false);but3.setEnabled(false);but4.setEnabled(false);
	but0.setVisible(false);but1.setVisible(false);but2.setVisible(false);but3.setVisible(false);but4.setVisible(false);
	
	base=new QuestionIO(level);
	for(int i=0;i<base.base.length;i++){if(base.base[i].level==level)qNumber++;}
	qLevel=level;setLabelText(getLabelText());
	t=new Thread(PointsIQ.this);t.start();
	
	//try{repaint();}catch(Exception e){}
	nextTask();
}	
	
void selectLevel(){
	//System.out.println("+");
	but1.setEnabled(true);but2.setEnabled(true);but3.setEnabled(true);but4.setEnabled(true);
	but0.setVisible(true);but1.setVisible(true);but2.setVisible(true);but3.setVisible(true);but4.setVisible(true);
	butText.setVisible(false);labelCoordinates.setVisible(false);label.setVisible(false);butNext.setVisible(false);butRePlay.setVisible(false);
	
	repaint();
}

public void init(){
	
	setSize(350,530);
	this.setContentPane(new Container());
	this.getContentPane().addMouseListener(this);
	this.getContentPane().addMouseMotionListener(this);
	
	but0=new JButton(); but0.setBounds(70, 165, 215, 25);but0.setText("<html>  :");
	but0.setEnabled(false);getContentPane().add(but0);but0.setBackground(Color.white);
	
	but1=new JButton(); but1.setBounds(120, 200, 95, 25);but1.setText("<html> 1");
	but1.addActionListener(new ActionListener(){public void actionPerformed(ActionEvent e){setLevel(1);}});
	getContentPane().add(but1);	
	
	but2=new JButton(); but2.setBounds(120, 230, 95, 25);but2.setText("<html> 2");
	but2.addActionListener(new ActionListener(){public void actionPerformed(ActionEvent e){setLevel(2);}});
	getContentPane().add(but2);	
	
	but3=new JButton(); but3.setBounds(120, 260, 95, 25);but3.setText("<html> 3");
	but3.addActionListener(new ActionListener(){public void actionPerformed(ActionEvent e){setLevel(3);}});
	getContentPane().add(but3);	
	
	but4=new JButton(); but4.setBounds(120, 290, 95, 25);but4.setText("<html> 4");
	but4.addActionListener(new ActionListener(){public void actionPerformed(ActionEvent e){setLevel(4);}});
	getContentPane().add(but4);	
	
	butText=new JButton();butText.setBounds(10, 390, 330, 105);
	butText.setEnabled(false);butText.setForeground(Color.black);butText.setBackground(Color.white);
	
	labelCoordinates.setBounds(10, 5, 70, 20);label.setBounds(70, 5, 270, 17);
	
	butNext=new JButton(); butNext.setBounds(10, 500, 95, 25);butNext.setText("<html>");
	butNext.addActionListener(new ActionListener(){public void actionPerformed(ActionEvent e){nextTask();}});	
	
	butRePlay=new JButton();butRePlay.setBounds(115, 500, 95, 25);butRePlay.setText("<html>");
	butRePlay.addActionListener(new ActionListener(){public void actionPerformed(ActionEvent e) {preTask();}});	
	
	getContentPane().add(butText);
	getContentPane().add(labelCoordinates);
	getContentPane().add(label);
	getContentPane().add(butNext);
	getContentPane().add(butRePlay);
	
	butText.setVisible(false);labelCoordinates.setVisible(false);label.setVisible(false);butNext.setVisible(false);butRePlay.setVisible(false);
		
}
	
private void nextTask(){
	butNext.setEnabled(false);butRePlay.setEnabled(false);
	curLevel=0;preLevels="";AIAnswer=null;isRePlay=false;
	
	for(int i=curQuestion;i<=base.base.length;i++){
		if(i==base.base.length){
			//new JOptionPane().showMessageDialog(null,"<html> .<br>  "+qTrue+"  "+qThis);
			selectLevel();
			break;
		}
		if(base.base[i].level==qLevel){
			curQuestion=i+1;question=base.getQuestion(base.base[i].index);
			newGame();isComplete=false;showQuestion();t=new Thread(PointsIQ.this);t.start();break;
		}
	}
}

private void preTask(){
	butNext.setEnabled(false);butRePlay.setEnabled(false);
	curLevel=0;preLevels="";AIAnswer=null;isRePlay=true;
	
	question=base.getQuestion(base.base[curQuestion-1].index);
	newGame();isComplete=false;showQuestion();t=new Thread(PointsIQ.this);t.start();
}

public void mousePressed(MouseEvent me) {
	int x=getMouseClickX(me);
	int y=getMouseClickY(me);
		
	if(!isComplete){
		if(isCanMakeMove(x,y)){
			OP_paint.setLastHuman(x,y);OP_paint.setLastAI(-1,-1);makeMove(x,y, SingleGameEngine.MoveType.BLUE);
			if(isExistsLevelMove(x,y)){
				if(isCanMakeMove(AIAnswer.x,AIAnswer.y)){OP_paint.setLastHuman(-1, -1);OP_paint.setLastAI(AIAnswer.x,AIAnswer.y);makeMove(AIAnswer.x,AIAnswer.y, SingleGameEngine.MoveType.RED);}
				else {
					isComplete=true;
					if(!isRePlay){qTrue++;qThis++;}
					setLabelText(getLabelText());
					butText.setText("<html><font color=green>  !");
					butNext.setEnabled(true);
					t=new Thread(PointsIQ.this);t.start();
				}
			}
		}
	}
}

public boolean isExistsLevelMove(int x,int y){
	Question.Makros.MakrosLevelMove moves[]=question.makros.getMoves();
	for(int i=0;i<moves.length;i++){
		if(moves[i].levelNumber==(curLevel+1)){
			if((moves[i].humanPoint.x)==x&(moves[i].humanPoint.y)==y&preLevels.equals(moves[i].preLevels)){
				AIAnswer=new Point(moves[i].AIPoint.x,moves[i].AIPoint.y);
				preLevels=moves[i].preLevels+moves[i].levelLetter;
				curLevel++;return true;
			}
		}
	}
	isComplete=true;
	if(!isRePlay){qThis++;}
	setLabelText(getLabelText());
	butText.setText("<html><font color=red>  !<br><font color=black>   :<br>"+question.comment);
	butNext.setEnabled(true);
	butRePlay.setEnabled(true);
	t=new Thread(PointsIQ.this);t.start();
	return false;
}

public void windowActivated(WindowEvent e) {t.stop();t=new Thread(this);t.start();}

public void showQuestion(){
	qLevel=question.level;
	butText.setText("<html> :<br>"+question.text);
	showStartPos(question.startPos);
	setLabelText(getLabelText());	
	repaint();
}

public void showStartPos(String str){
	String move;
	while(str.length()>1){
		move=str.substring(str.indexOf("[")+1,str.indexOf("]"));
		str=str.substring(str.indexOf("]")+1);
		int x=new Integer(move.substring(0,move.indexOf(",")));move=move.substring(move.indexOf(",")+1);
		int y=new Integer(move.substring(0,move.indexOf(",")));move=move.substring(move.indexOf(",")+1);
		if(move.equals("R")){OP_paint.setLastHuman(-1, -1);OP_paint.setLastAI(x, y);singleGameEngine.makeMove(x,y, SingleGameEngine.MoveType.RED);}
		else {OP_paint.setLastAI(-1, -1);OP_paint.setLastHuman(x, y);singleGameEngine.makeMove(x,y, SingleGameEngine.MoveType.BLUE);}
	}
}

public void run(){try{try{t.sleep(200);}catch(Exception e){}repaint();t.stop();}catch(Exception e){}}
void makeMove(int x, int y,SingleGameEngine.MoveType moveType){singleGameEngine.makeMove(x,y,moveType);setLabelText(getLabelText());repaint();}
void newGame(){setLabelText(getLabelText());singleGameEngine=new SingleGameEngine(sizeX,sizeY);}	

public void mouseMoved(MouseEvent me){try{
	if(getMouseClickX(me)!=preX|getMouseClickY(me)!=preY){
		Graphics graphics=this.getGraphics();
		if(isCanMakeMove(preX, preY)){
			graphics.setColor(Color.white);
			graphics.drawOval(preX*squareSize+9, preY*squareSize+41, 6, 6);
			graphics.setColor(new Color(225,225,225));
			graphics.drawLine(preX*squareSize+9, preY*squareSize+44, preX*squareSize+15, preY*squareSize+44);
			graphics.drawLine(preX*squareSize+12, preY*squareSize+41, preX*squareSize+12, preY*squareSize+47);
		}		
		preX=getMouseClickX(me);preY=getMouseClickY(me);	
		if(preX>0&preX<(sizeX+1)&preY>0&preY<(sizeY+1))labelCoordinates.setText("<HTML><font color=gray>"+preX+":"+preY);
		if(isCanMakeMove(preX, preY)){
			graphics.setColor(Color.blue);
			graphics.drawOval(preX*squareSize+9, preY*squareSize+41, 6, 6);
		}
	}
}catch(Exception e){}}

boolean isCanMakeMove(int x, int y){return singleGameEngine.canMakeMove(x,y);}
int getMouseClickX(MouseEvent me){return (int)(((double)me.getX()-5-(double)((offsetX-1)*squareSize))/(double)squareSize);};
int getMouseClickY(MouseEvent me){return (int)(((double)me.getY()-5-(double)((offsetY-1)*squareSize))/(double)squareSize);};
public void repaint(){
	graphics=getGraphics();
	graphics.setColor(new Color(254,254,254));
	graphics.fillRect(0, 50, squareSize*(sizeX+1+offsetX), sizeY*(squareSize+1));
	OP_paint.paint(graphics, singleGameEngine);
}
String getLabelText(){return "<HTML>"+spc+" <FONT color=blue>"+qNumber+"</FONT>"+spc+" "+"<FONT color=blue> "+qTrue+"  "+qThis+"</FONT></HTML>";}
public void setLabelText(String text){label.setText(text);}	
public void mouseClicked(MouseEvent me) {}
public void mouseEntered(MouseEvent me) {}
public void mouseExited(MouseEvent me) {}
public void mouseReleased(MouseEvent me) {}
public void mouseDragged(MouseEvent arg0) {}

public class C_Layout implements LayoutManager {//

	int width;// 
	int height;// 

public C_Layout(int width,int height){// 
		this.width=width;// ,   
		this.height=height;// ,   
		}

public void addLayoutComponent(String name, Component comp) {  }
public void removeLayoutComponent(Component comp) { }
public Dimension preferredLayoutSize(Container parent) {
        return new Dimension(width, height);        }
public Dimension minimumLayoutSize(Container parent) {
    	return new Dimension(width, height);        }
public void layoutContainer(Container parent) {  }
}

}